#include <stdio.h>
#include <stdlib.h>

void print_bits(int n, int j)
{
	printf("(");

	for (int k = 0; k < n; k++) {
		int b = n - k - 1;
		int bit_b = ((j & (1 << b)) != 0);

		printf("%d", bit_b);
	}

	printf(")b");
}

int compute_popcount(int n, int j)
{
	int count = 0;

	for (int b = 0; b < n; b++) {
		count += ((j & (1 << b)) != 0);
	}

	return count;
}

int compute_popcount_using_instruction(int j)
{
	return __builtin_popcount(j);
}


int main(int argc, char **argv)
{
	if (argc != 2) {
		printf("Usage: %s {n}\n", argv[0]);
		return 0;
	}

	int n = strtol(argv[1], NULL, 0);

	if (n >= (int)sizeof(int) * 8 - 1) {
		printf("%d too large for signed int type\n", n);
	}

	for (int j = 0; j < (1 << n); j++) {
		printf("j = %3d; ", j);
		print_bits(n, j);
		printf("; count = %d\n", compute_popcount(n, j));
	}

	return 0;
}
